package AndroidSlider.SliderLibrary;

import java.io.File;
import java.util.HashMap;
  



import com.daimajia.slider.library.SliderLayout;
import com.daimajia.slider.library.Animations.DescriptionAnimation;
import com.daimajia.slider.library.SliderTypes.BaseSliderView;
import com.daimajia.slider.library.SliderTypes.TextSliderView;

import android.content.Context;
 
import android.renderscript.Type;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
@ActivityObject
@ShortName("Slider")
@Version(1.0f)
@Permissions(values = {"android.permission.ACCESS_NETWORK_STATE", "android.permission.READ_EXTERNAL_STORAGE","android.permission.INTERNET", "android.permission.WAKE_LOCK","android.permission.WRITE_EXTERNAL_STORAGE" })
@DependsOn(values={"Library","android-support-v4","android-support-v7-appcompat", "picasso","nineoldandroids"})
@Events(values={"Playing",
		"Stopped",
		"Paused",
		"Resumed",
		"ImageChanged(index as Int)"
		})
 
public class Slider extends anywheresoftware.b4a.objects.ViewWrapper<SliderLayout>{
	HashMap<String,String> url_maps = new HashMap<String, String>();
	HashMap<String,String> file_maps = new HashMap<String, String>();
	Context mCont;
	  /**
     * preset transformers and their names
     */
	public static final int SLIDER_TRANSITION_Default=0;
	public static final int SLIDER_TRANSITION_Accordion=1;
	public static final int SLIDER_TRANSITION_Background2Foreground=2;
	public static final int SLIDER_TRANSITION_CubeIn=3;
	public static final int SLIDER_TRANSITION_DepthPage=4;
	public static final int SLIDER_TRANSITION_Fade=5;
	public static final int SLIDER_TRANSITION_FlipHorizontal=6;
	public static final int SLIDER_TRANSITION_FlipPage=7;
	public static final int SLIDER_TRANSITION_Foreground2Background=8;
	public static final int SLIDER_TRANSITION_RotateDown=9;
	public static final int SLIDER_TRANSITION_RotateUp=10;
	public static final int SLIDER_TRANSITION_Stack=11;
	public static final int SLIDER_TRANSITION_Tablet=12;
	public static final int SLIDER_TRANSITION_ZoomIn=13;
	public static final int SLIDER_TRANSITION_ZoomOutSlide=14;
	public static final int SLIDER_TRANSITION_ZoomOut=15;

    private SliderLayout.Transformer currenttransition;
    public int Delay=4000;
public void SetTransition(int SLIDER_TRANSITION )
{

	switch(SLIDER_TRANSITION)
	{
	case SLIDER_TRANSITION_Default:
		currenttransition=SliderLayout.Transformer.Default;
		break;
	case SLIDER_TRANSITION_Accordion:
		currenttransition=SliderLayout.Transformer.Accordion;
		break;
	case SLIDER_TRANSITION_Background2Foreground:
		currenttransition=SliderLayout.Transformer.Background2Foreground;
		break;
	case SLIDER_TRANSITION_CubeIn:
		currenttransition=SliderLayout.Transformer.CubeIn;
		break;
	case SLIDER_TRANSITION_DepthPage:
		currenttransition=SliderLayout.Transformer.DepthPage;
		break;
	case SLIDER_TRANSITION_Fade:
		currenttransition=SliderLayout.Transformer.Fade;
		break;
	case SLIDER_TRANSITION_FlipHorizontal:
		currenttransition=SliderLayout.Transformer.FlipHorizontal;
		break;
	case SLIDER_TRANSITION_FlipPage:
		currenttransition=SliderLayout.Transformer.FlipPage;
		break;
	case SLIDER_TRANSITION_Foreground2Background:
		currenttransition=SliderLayout.Transformer.Foreground2Background;
		break;
	case SLIDER_TRANSITION_RotateDown:
		currenttransition=SliderLayout.Transformer.RotateDown;
		break;
	case SLIDER_TRANSITION_RotateUp:
		currenttransition=SliderLayout.Transformer.RotateUp;
		break;
	case SLIDER_TRANSITION_Stack:
		currenttransition=SliderLayout.Transformer.Stack;
		break;
	case SLIDER_TRANSITION_Tablet:
		currenttransition=SliderLayout.Transformer.Tablet;
		break;
	case SLIDER_TRANSITION_ZoomIn:
		currenttransition=SliderLayout.Transformer.ZoomIn;
		break;
	case SLIDER_TRANSITION_ZoomOutSlide:
		currenttransition=SliderLayout.Transformer.ZoomOutSlide;
		break;
	case SLIDER_TRANSITION_ZoomOut:
		currenttransition=SliderLayout.Transformer.ZoomOut;
		break;
	}
	
}

	/**
	 * AndroidSlider currently wraps version x
	 * https://github.com/daimajia/AndroidImageSlider
	 */	
	public static void LIBRARY_DOC() {
	}
 	
	@Override
	public void Initialize(BA pBA, String EventName) {
		mCont=pBA.context;
	    this.ba=pBA;

		super.Initialize(pBA, EventName);
	}    
	
	@Hide
	@Override
	public void innerInitialize(final BA pBA, final String pEventName, boolean pKeepOldObject) {
		
		if (!pKeepOldObject) {
			
			url_maps = new HashMap<String, String>();
		
			SliderLayout mDemoSlider=new SliderLayout(mCont); 
	 
			
			
			setObject(mDemoSlider); 
			pKeepOldObject=true;
		}
		
		super.innerInitialize(pBA, pEventName, pKeepOldObject);

	}	

	public void AddSlide(String Name,String URL)
	{
        url_maps.put(Name, URL); 
 
	}
	
	public void AddImageFile(String Name,String FileName)
	{
	  
        file_maps.put(Name, FileName); 
 
	}	
	@Override
	public void SetLayout(int Top, int Left, int Width, int Height) {
		super.SetLayout(Left, Top, Width, Height);
	}

	
	/**
	 * Starts or resumes playing.
	 */
	public void Start() {
		((SliderLayout) getObject()).removeAllSliders();
		
		 for(String name : url_maps.keySet()){//Add Online path
	            TextSliderView textSliderView = new TextSliderView(mCont);
	            // initialize a SliderLayout
	            textSliderView
	                    .description(name)
	                    .image(url_maps.get(name))
	                    .setScaleType(BaseSliderView.ScaleType.Fit);

	            //add your extra information
	            textSliderView.getBundle()
	                    .putString("extra",name);

	           ((SliderLayout) getObject()).addSlider(textSliderView);
	        }
		 
		 for(String name : file_maps.keySet()){//Add local files
	            TextSliderView textSliderView = new TextSliderView(mCont);
	            // initialize a SliderLayout
	            File fl=new File(file_maps.get(name));
	            textSliderView
	                    .description(name)
	                    .image(fl)
	                    .setScaleType(BaseSliderView.ScaleType.Fit);

	            //add your extra information
	            textSliderView.getBundle()
	                    .putString("extra",name);

	           ((SliderLayout) getObject()).addSlider(textSliderView);
	        }		 
		 
		 ((SliderLayout) getObject()).setPresetTransformer(currenttransition);
		 ((SliderLayout) getObject()).setPresetIndicator(SliderLayout.PresetIndicators.Left_Bottom);
		 ((SliderLayout) getObject()).setCustomAnimation(new DescriptionAnimation());
		 ((SliderLayout) getObject()).setDuration(Delay);
 
	}
	/**
	 * Stops the playback.
	 */
	public void Pause() {
		((SliderLayout) getObject()).stopAutoCycle();
	}	
 
	/**
	 * Resumes the playback.
	 */
	public void Resume() {
		((SliderLayout)  getObject()).startAutoCycle();
	}
 
	static class ExtendedBALayout extends BALayout {
	      private int lastHeight = -1;
	      private final String eventName;
	      private final BA ba;
	      public ExtendedBALayout(Context context, String EventName, BA ba) {
	         super(context);
	         this.eventName = EventName.toLowerCase(BA.cul);
	         this.ba = ba;
	      }
	      @Override
	      protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
	         int height = MeasureSpec.getSize(heightMeasureSpec);
	         if (height != lastHeight && lastHeight != -1) {
	            ba.raiseEvent(null, eventName + "_heightchanged", height, lastHeight);
	         }
	         lastHeight = height;
	         super.onMeasure(widthMeasureSpec, heightMeasureSpec);       
	      }

	   }

}

